package yrpg.bamp.basedata.plugin.util;

import kd.bos.dataentity.entity.DynamicObject;
import kd.bos.servicehelper.BusinessDataServiceHelper;
import kd.bos.servicehelper.operation.SaveServiceHelper;
import kd.bos.servicehelper.parameter.SystemParamServiceHelper;
import org.apache.http.client.methods.CloseableHttpResponse;
import org.apache.http.client.methods.HttpPost;
import org.apache.http.entity.StringEntity;
import org.apache.http.impl.client.CloseableHttpClient;
import org.apache.http.impl.client.HttpClients;
import org.apache.http.util.EntityUtils;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

import java.io.IOException;
import java.nio.charset.Charset;
import java.util.Date;
import java.util.Map;

public class ExpenseItemApiUtil {
    private static Logger logger = LoggerFactory.getLogger(ExpenseItemApiUtil.class);

    public static String getHttp(String param,String url){
        // 创建httpClient
        CloseableHttpClient httpClient = HttpClients.createDefault();
        // 创建post请求方式实例
        HttpPost httpPost = new HttpPost(url);

        // 设置请求头 发送的是json数据格式
        httpPost.setHeader("Content-type", "application/json;charset=utf-8");

        //  can not cast to JSONObject.
        //保存推送报文日志
        //savePushReportLog(invoiceMap);
        // 设置参数---设置消息实体 也就是携带的数据
        StringEntity entity = new StringEntity(param, Charset.forName("UTF-8"));
        // 设置编码格式
        entity.setContentEncoding("UTF-8");
        // 发送Json格式的数据请求
        entity.setContentType("application/json");
        // 把请求消息实体塞进去
        httpPost.setEntity(entity);

        // 执行http的post请求
        CloseableHttpResponse httpResponse;
        String result = null;
        try {
            httpResponse = httpClient.execute(httpPost);
            result = EntityUtils.toString(httpResponse.getEntity(), "UTF-8");

        } catch (IOException e) {
            e.printStackTrace();
        }
        return result;
    }

    /**
     * 保存日志
     *
     * @param logMap
     */
    public static void saveApiLog(Map<String, Object> logMap) {

        DynamicObject apiLog = BusinessDataServiceHelper.newDynamicObject("openapi_log_data");
        //api编号
        apiLog.set("opname", logMap.get("opname"));
        //URL
        apiLog.set("opdesc", logMap.get("opdesc"));
        //请求参数
        if (logMap.get("request") != null) {
            apiLog.set("request", logMap.get("request").toString().length() > 1500 ? logMap.get("request").toString().substring(0, 1500) : logMap.get("request"));
        } else {
            apiLog.set("request", "");
        }

        if (logMap.get("response") != null) {
            //响应结果
            apiLog.set("response", logMap.get("response").toString().length() > 1500 ? logMap.get("response").toString().substring(0, 1500) : logMap.get("response"));
        } else {
            apiLog.set("response", "");
        }

        //调用时间
        apiLog.set("opdate", new Date());
        //调用者
        apiLog.set("username", logMap.get("username"));
        //第三方应用
        apiLog.set("thirdappname", logMap.get("thirdappname"));
        //调用状态
        apiLog.set("status", logMap.get("status"));
        //保存日志
        SaveServiceHelper.save(new DynamicObject[]{apiLog});

    }
}
